Subject: Re: bug#5410: Parenthesis Matching Bug!!

From: Andrew Hyatt <[email-masked]>
Date: Thu, 04 Aug 2016 20:17:08 +0000

On Wed, Aug 3, 2016 at 10:55 PM Michael Heerdegen <[email-masked]>
wrote:

> Andrew Hyatt <[email-masked]> writes:
>
> > Your example reproduces for me in Emacs 25. My guess is that emacs
> > doesn't really assume that comment lines should be treated as a
> > contiguous text block. Which is sometimes right, sometimes not, in my
> > experience.
>
> We are talking about `show-paren-mode', right?  AFAICT this just calls
> `scan-sexps' and looks if that errors or not, without doing syntactical
> analysis itself.
>

> `parse-sexp-ignore-comments' influences `scan-sexps's behavior in this
> regard, and setting it to nil does change the behavior in this case for
> me.  I guess we could use this for a solution.2
>

Yes, this works to resolve the issue for me too.  Are you saying it should
default to nil always, or for cc-mode?  It seems like setting this to nil
might cause other issues we wouldn't want; ignoring comments usually seems
like the right thing to do.

It'd be nice, I guess, if you could just turn it to nil when in a comment.

>
> > For example, you could have comments that are something
> > like:
> >
> > // This function does three things:
> > // 1) Reverse the string
> > // 2) Uuencode the string
> > // 3) Rot-13 the string
> >
> > Which certainly wouldn't make a lot of sense treated contiguously.
>
> Well, we would not loose anything in this case: parens are already shown
> as mismatches now.
>
>
True, I guess my point is that it'd be strange to consider this as 3
unmatched parens rather than 1 per line.

> Michael.